# -*- coding: utf-8 -*-
 
       
class Lnode(object):
    def __init__(self, nodeid, nodelabel=None):
        self.nodeid=nodeid
        self.nodelabel=nodelabel
        self.outnodes=[]
    def addneighbor(self, neighlist):
        self.outnodes.extend(neighlist)
    def __str__(self):
        return self.nodeid+"["+self.nodelabel+"]"

        
class LDarc(object):
    def __init__(self, arcid, nodefrom, nodeto, arclabel=None):
        self.arcid=arcid
        self.nodefrom=nodefrom
        self.nodeto=nodeto
        self.arclabel=arclabel
    def __str__(self):
        return str(self.arcid)+" ("+str(self.nodefrom.nodeid)+")--"+str(self.arclabel)+"-->("+str(self.nodeto.nodeid)+")"

        
class LDgraph(object):
    def __init__(self, nodelist, arclist=None):
        self.nodelist=[]
        self.addnodes(nodelist)
        self.arclist=[]
        if arclist:
            self.addarcs(arclist)
        self.sortbylabels()

    def addnodes(self, nodelist):
        if nodelist:
            for node in nodelist:
                if node not in self.nodelist:
                    self.nodelist.append(node)

    def addarcs(self, arclist):
        if arclist:
            for arc in arclist:
                try:
                    ito=self.nodelist.index(arc.nodeto)
                    ifrom=self.nodelist.index(arc.nodefrom)
                    self.nodelist[ifrom].addneighbor([self.nodelist[ito]])
                    self.arclist.append(arc)
                except ValueError:
                    continue
    
    def sortbylabels(self, rev=False):
        self.nodelist.sort(key=lambda node: node.nodelabel, reverse=rev)
        self.arclist.sort(key=lambda arc: arc.arclabel, reverse=rev)
                
    def __str__(self):
        out= "Vertices:\n"
        for node in self.nodelist:
            out+=str(node)
            outnodes=node.outnodes[:]
            outnodes.sort(key=lambda node: node.nodeid)
            for nto in outnodes:
                out+=" ->"+str(nto.nodeid)
            out+='\n'
        out+= "Arcs:\n"
        for arc in self.arclist:
            out+=str(arc)+'\n'
        return out
