# -*- coding: utf-8 -*-

#3a) Un grafo diretto è composto da nodi e archi (diretti) tra coppie di nodi. 
# Ciascun nodo è individuato da un'identificatore unico, e ciascun arco anche. 
# A ciascun nodo e a ciascun arco può essere associata una etichetta ("label") 
# con un contenuto informativo. Nel file labelgraph.py è riportata la classe 
# "LDgraph" che permette di rappresentare grafi diretti con etichette.
# Si scriva una funzione "buildadjac" che, data in input una lista di stringhe 
# tutte diverse tra loro, restituisca una istanza di LDgraph con un nodo per 
# stringa (da usarsi sia come label che come id del nodo) e che, per ogni 
# coppia di nodi con label l1 e l2 per cui valga la condizione l1[1:]==l2[:-1], 
# contenga l'arco tra i due, con id e label pari a l1+ld[-1].


import labelgraph as lg

def buildadjac(slist):
    nodelist=[]
    arclist=[]
    for x in slist:
        nodelist.append(lg.Lnode(x, x))
    for n1 in nodelist:
        for n2 in nodelist:
            if n1.nodelabel[1:]==n2.nodelabel[:-1]:
                arcid = n1.nodelabel+n2.nodelabel[-1]
                arclist.append(lg.LDarc(arcid, n1, n2, arcid))
    return lg.LDgraph(nodelist, arclist)
